debug = true;
smallTubeDiameter = 100;
smallTubeWall = 1.8;
smallTubeHeight = 750; // used for debug

bigTubeDiameter = 125;
bigTubeWall = 3.2;
bigTubeHeight = 1450; // used for debug

printHeight = 210;

bottomThickness = 5;


printMargin = 0.6; // Print margin so the tubes will fit

//////////////////////////////////////
// TODO: estimate according to tube thicknessess
taperHeight = 38;
echo("######################");
//echo(str(sin(90)* bigTubeDiameter));
//echo(str(sin(90)* bigTubeDiameter));
//echo(tan(90)); // degrees to number (90 = inf)
//echo(atan(99)); // number to degrees
//echo(atan2(1,1)); // x/y to degrees

echo("######################");
$fn = 250;

difference()
{
    union()
    {
        translate([0,0,printHeight-taperHeight])
        sphere(d=bigTubeDiameter); // tube tapering
        cylinder(printHeight-taperHeight,d=bigTubeDiameter-2*bigTubeWall); // big tube inner
    }

    translate([0,0,-1])
    cylinder(printHeight+(bigTubeDiameter/2+2.5),d=smallTubeDiameter+printMargin); // small tube outer + sphere

    translate([0,0,0])
    difference()
    {
        translate([0,0,-1])
        cylinder(printHeight-taperHeight-1,d=bigTubeDiameter); // big tube outer
        translate([0,0,-1])
        cylinder(printHeight-taperHeight+2,d=bigTubeDiameter-2*bigTubeWall-printMargin); // big tube inner
    }

    translate([0,0,-printHeight])
    cylinder(printHeight,d=bigTubeDiameter+10); // cut off tube
}


// Bottom flange
difference()
{
    cylinder(bottomThickness,d=bigTubeDiameter-2*bigTubeWall-printMargin-1);
    translate([0,0,-1])
    cylinder(bottomThickness+2,d=smallTubeDiameter-2*smallTubeWall-1); // extra 1 mm flange
}

if (debug)
{
    #translate([0,0,bottomThickness])
    difference()
    {
        cylinder(smallTubeHeight+printHeight-bottomThickness,d=smallTubeDiameter); // small tube outer
        translate([0,0,-1])
        cylinder(smallTubeHeight+2,d=smallTubeDiameter-2*smallTubeWall); // small tube inner
    }

    #translate([0,0,printHeight-bigTubeHeight-taperHeight])
    difference()
    {
        cylinder(bigTubeHeight,d=bigTubeDiameter); // big tube outer
        translate([0,0,-1])
        cylinder(bigTubeHeight+2,d=bigTubeDiameter-2*bigTubeWall); // big tube inner
    }
}
